1. 程式人生 > >【Leetcode】235. Lowest Common Ancestor of a Binary Search Tree二叉搜尋樹的最近公共祖先

【Leetcode】235. Lowest Common Ancestor of a Binary Search Tree二叉搜尋樹的最近公共祖先

  1. Lowest Common Ancestor of a Binary Search Tree
    二叉搜尋樹的最近公共祖先
    Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.
    According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”
    Given binary search tree: root = [6,2,8,0,4,7,9,null,null,3,5]
    ![在這裡插入圖片描述](
    https://img-blog.csdnimg.cn/20181130110639960.png?x-oss-process=image/wat
    在這裡插入圖片描述
    Example 1:
    Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
    Output: 6
    Explanation: The LCA of nodes 2 and 8 is 6.
    Example 2:
    Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
    Output: 2
    Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.
    Note:
    All of the nodes’ values will be unique.
    p and q are different and both values will exist in the BST.
    給定一個二叉搜尋樹, 找到該樹中兩個指定節點的最近公共祖先。

百度百科中最近公共祖先的定義為:“對於有根樹 T 的兩個結點 p、q,最近公共祖先表示為一個結點 x,滿足 x 是 p、q 的祖先且 x 的深度儘可能大(一個節點也可以是它自己的祖先)。”

例如,給定如下二叉搜尋樹: root = [6,2,8,0,4,7,9,null,null,3,5]
在這裡插入圖片描述

示例 1:
輸入: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
輸出: 6
解釋: 節點 2 和節點 8 的最近公共祖先是 6。
示例 2:

輸入: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
輸出: 2
解釋: 節點 2 和節點 4 的最近公共祖先是 2, 因為根據定義最近公共祖先節點可以為節點本身。
說明:

所有節點的值都是唯一的。
p、q 為不同節點且均存在於給定的二叉搜尋樹中。

[思路]:
此題的關鍵在於是二叉搜尋樹,即任一節點r的左(右)子樹中,所有節點(若存在)均不大於(不小於)r。
所以p,q 比root小, 則LCA必定在左子樹, 如果p,q比root大, 則LCA必定在右子樹. 如果一大一小, 則root即為LCA. 利用迭代法。
[程式碼C++]:
class Solution {
public:
TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p,
TreeNode* q) {

   if( root == NULL || p == NULL || q == NULL) return NULL;
    if(p->val < root->val && q ->val < root -> val)
        return lowestCommonAncestor(root->left, p, q);
    else if(p->val > root->val && q ->val > root -> val)
        return lowestCommonAncestor(root->right, p, q);
          else return root;        
}

};